## foo-yc20 1.3.0

=== Makefile ===
PREFIX=/usr/local
VERSION=1.3.0

OBJS_NODEPS=src/lv2.o src/foo-yc20.o src/configuration.o
OBJS_JACK=src/yc20-jack.o src/main-cli.o
OBJS_GTKJACK=src/main-gui.o src/foo-yc20-ui.o
OBJS_GTK=src/foo-yc20-ui2.o src/lv2-ui.o
OBJS_CAIRO=src/yc20-base-ui.o

OBJS_DSP_STANDALONE=src/faust-dsp-standalone.o
OBJS_DSP_PLUGIN=src/faust-dsp-plugin.o

LV2_PLUGIN=src/foo-yc20.lv2/foo-yc20.so
LV2_UI=src/foo-yc20.lv2/foo-yc20-lv2ui.so

ifeq ($(CFLAGS),)
ifeq ($(shell uname), Darwin)
CFLAGS=-O3 -ffast-math -ftree-vectorize -arch ppc -arch i386 -arch x86_64
else
CFLAGS=-O3 -mtune=native -march=native -mfpmath=sse -ffast-math -ftree-vectorize 
endif
endif

CFLAGS_X = $(CFLAGS) -fPIC -DVERSION=$(VERSION) -Isrc/ -Iinclude/ -DPREFIX=$(PREFIX) -Wall

$(OBJS_NODEPS): CFLAGS_use = $(CFLAGS_X) 
$(OBJS_JACK): CFLAGS_use = $(CFLAGS_X) `pkg-config --cflags jack`
$(OBJS_GTKJACK): CFLAGS_use = $(CFLAGS_X) `pkg-config --cflags gtk+-2.0` `pkg-config --cflags jack`
$(OBJS_GTK): CFLAGS_use = $(CFLAGS_X) `pkg-config --cflags gtk+-2.0`
$(OBJS_LV2): CFLAGS_use = $(CFLAGS_X)
$(OBJS_CAIRO): CFLAGS_use = $(CFLAGS_X) `pkg-config --cflags cairo`

$(OBJS_DSP_STANDALONE) $(OBJS_DSP_PLUGIN): CFLAGS_use = $(CFLAGS_X)

.cpp.o:
	$(CXX) $< $(CFLAGS_use) -c -o $@

all: foo-yc20 foo-yc20-cli lv2

lv2: $(LV2_PLUGIN) $(LV2_UI)

## GUI version
OBJS_FOO_YC20=src/foo-yc20.o src/configuration.o src/yc20-jack.o src/main-gui.o src/foo-yc20-ui.o src/yc20-base-ui.o $(WIN32_RC)

foo-yc20: $(OBJS_FOO_YC20) $(OBJS_DSP_STANDALONE)
	$(CXX) $(OBJS_FOO_YC20) $(OBJS_DSP_STANDALONE) `pkg-config --libs gtk+-2.0` `pkg-config --libs jack` $(LDFLAGS_YC20) -o foo-yc20

## CLI version
OBJS_FOO_YC20_CLI=src/foo-yc20.o src/configuration.o src/main-cli.o src/yc20-jack.o

foo-yc20-cli: $(OBJS_FOO_YC20_CLI) $(OBJS_DSP_STANDALONE)
	$(CXX) $(OBJS_FOO_YC20_CLI) $(OBJS_DSP_STANDALONE) $(LDFLAGS_YC20_CLI) `pkg-config --libs jack` -o foo-yc20-cli

## LV2 version
OBJS_LV2=src/lv2.o src/foo-yc20.o

$(LV2_PLUGIN): $(OBJS_LV2) $(OBJS_DSP_PLUGIN)
	$(CXX) $(OBJS_LV2) $(OBJS_DSP_PLUGIN) -fPIC -shared -o $(LV2_PLUGIN) $(LDFLAGS_YC20_LV2)

## LV2 UI
OBJS_LV2_UI=src/lv2-ui.o src/foo-yc20-ui2.o src/yc20-base-ui.o

$(LV2_UI): $(OBJS_LV2_UI)
	$(CXX) $(OBJS_LV2_UI) -fPIC -shared `pkg-config --libs gtk+-2.0` -o $(LV2_UI) $(LDFLAGS_YC20_LV2)

## VSTi - only compiles for windows with MinGW32. 
##        Note: Jack is used in compile flags to provide access to the ringbuffer.h. there
##              is no runtime dependency or even a library as we use the separately compiled ringbuffer.o
OBJS_VSTI=src/vsti.o src/vstplugmain.o src/foo-yc20.o src/yc20-base-ui.o $(WIN32_RC)
$(WIN32_RC): src/win32.rc
	$(WINDRES) src/win32.rc -o src/win32.o

src/vsti.o src/vstplugmain.o: CFLAGS_use = $(CFLAGS_X) -I$(VSTSDK) -I$(VSTSDK)/public.sdk/source/vst2.x `pkg-config --cflags cairo jack`

src/vstplugmain.o: $(VSTSDK)/public.sdk/source/vst2.x/vstplugmain.cpp
	$(CXX) $(CFLAGS_use)  $(VSTSDK)/public.sdk/source/vst2.x/vstplugmain.cpp -c -o src/vstplugmain.o

vsti: $(OBJS_VSTI) $(OBJS_DSP_PLUGIN) src/vsti.def
	$(CXX) -Wall -s -shared -mwindows -static src/vsti.def $(VSTFLAGS) $(OBJS_VSTI) $(OBJS_DSP_PLUGIN) -o FooYC20.dll `pkg-config --libs cairo`

$(BIN): $(OBJ)

src/osxringbuffer.o: ../tools/win32/jack-1.9.6/jack-1.9.6/common/ringbuffer.c
	$(CC) $(CFLAGS) \
	-I../tools/win32/jack-1.9.6/jack-1.9.6/posix/ \
	-I../tools/win32/jack-1.9.6/jack-1.9.6/common/ \
	-c ../tools/win32/jack-1.9.6/jack-1.9.6/common/ringbuffer.c \
	-o src/osxringbuffer.o

src/osxresources.o: ../tools/osx/src/osxresources.mm
	$(CC) $(CFLAGS) -o src/osxresources.o -c ../tools/osx/src/osxresources.mm

vstosx: $(OBJS_VSTI) $(OBJS_DSP_PLUGIN) src/osxringbuffer.o src/osxresources.o
	$(CXX) $(CFLAGS) \
	-I$(VSTSDK)/public.sdk -I$(VSTSDK)/vstgui.sf -I$(VSTSDK)/ \
	`pkg-config --cflags cairo` \
	-bundle -framework Carbon -framework CoreFoundation -framework AppKit \
	`pkg-config --libs cairo` \
	src/osxringbuffer.o src/osxresources.o \
	$(OBJS_VSTI) $(OBJS_DSP_PLUGIN) \
	-o vstosx

## clean

clean: cb
	rm -f $(OBJS_DSP_STANDALONE) $(OBJS_DSP_PLUGIN)

cb:
	rm -f foo-yc20 foo-yc20-cli $(LV2_PLUGIN) $(LV2_UI) FooYC20.dll
	rm -f $(OBJS_FOO_YC20) $(OBJS_FOO_YC20_CLI) $(OBJS_LV2) $(OBJS_LV2_UI) $(OBJS_VSTI)
	rm -f src/osxringbuffer.o src/osxresources.o vstosx
	


install: foo-yc20
	install -Dm 755 foo-yc20 $(DESTDIR)$(PREFIX)/bin/foo-yc20
	install -Dm 755 foo-yc20-cli $(DESTDIR)$(PREFIX)/bin/foo-yc20-cli
	install -d $(DESTDIR)$(PREFIX)/share/foo-yc20/graphics
	install -m 644 graphics/*.png $(DESTDIR)$(PREFIX)/share/foo-yc20/graphics
	cat foo-yc20.desktop.in | sed 's!%PREFIX%!$(PREFIX)!' > foo-yc20.desktop
	install -Dm 644 foo-yc20.desktop $(DESTDIR)$(PREFIX)/share/applications/foo-yc20.desktop
	rm foo-yc20.desktop
	install -d $(DESTDIR)$(PREFIX)/lib/lv2/foo-yc20.lv2
	install -m 755 src/foo-yc20.lv2/*.so $(DESTDIR)$(PREFIX)/lib/lv2/foo-yc20.lv2
	install -m 644 src/foo-yc20.lv2/*.ttl $(DESTDIR)$(PREFIX)/lib/lv2/foo-yc20.lv2


uninstall:
	rm $(DESTDIR)$(PREFIX)/bin/foo-yc20
	rm $(DESTDIR)$(PREFIX)/share/applications/foo-yc20.desktop
	rm -r $(DESTDIR)$(PREFIX)/share/foo-yc20


## Targets only for those with Faust installed

generate-source:
	faust -a minimal.cpp faust/standalone.dsp > gen/yc20-dsp-standalone.cpp
	faust -a minimal.cpp faust/plugin.dsp     > gen/yc20-dsp-plugin.cpp

generate-source-vec:
	faust -vec -a minimal.cpp faust/standalone.dsp > gen/yc20-dsp-standalone.cpp
	faust -vec -a minimal.cpp faust/plugin.dsp     > gen/yc20-dsp-plugin.cpp


basic-test:
	faust -a jack-console.cpp faust/yc20.dsp > gen/basic.cpp
	$(CXX) $(CFLAGS) -Isrc/ gen/basic.cpp -o basic `pkg-config --cflags --libs jack`

## test compilation
# For semi-automated testing, this line is handy:
# make testit && ./testit in.wav out.wav && mhwaveedit out.wav

testit: faust/test.dsp faust/oscillator.dsp src/polyblep.cpp Makefile
	rm -rf faust/test-svg/
	faust -svg -a sndfile.cpp faust/test.dsp > gen/test.cpp
	$(CXX) $(CFLAGS) -Isrc/ gen/test.cpp `pkg-config --cflags --libs sndfile` -o testit

$(OBJS_NODEPS) $(OBJS_JACK) $(OBJS_GTKJACK) $(OBJS_LV2) $(OBJS_CAIRO): include/*.h

$(OBJS_DSP_STANDALONE): gen/yc20-dsp-standalone.cpp
$(OBJS_DSP_PLUGIN): gen/yc20-dsp-plugin.cpp

=== debian/changelog ===
foo-yc20 (1.3.0-6) unstable; urgency=medium

  * Team upload
  * Remove myself from Uploaders
  * Fix MIDI controller number for the "Pitch" control.
    Thanks to Alex Volkov for the patch (Closes: #712114)
  * Bump Standards-Version to 3.9.5 (no changes needed)
  * Bump debhelper compat level to 9
  * Drop outdated DM-Upload-Allowed header

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 01 Mar 2014 12:28:47 +0100

foo-yc20 (1.3.0-5) unstable; urgency=low

  * Replace lv2core with lv2-dev on Build-Depends.

 -- Alessio Treglia <alessio@debian.org>  Mon, 14 May 2012 18:29:08 +0200

foo-yc20 (1.3.0-4) unstable; urgency=low

  [ Alessandro Ghedini ]
  * Email change: Alessandro Ghedini -> ghedo@debian.org

  [ Alessio Treglia ]
  * Temporarily disable DSP sources re-generation to prevent SIGSEGV
    at startup. See upstream bug report for more information:
    http://code.google.com/p/foo-yc20/issues/detail?id=5
  * Update debian/copyrignt to format 1.0.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Thu, 26 Apr 2012 11:06:28 +0200

foo-yc20 (1.3.0-3) unstable; urgency=low

  * Get rid of Intel optimizations and -m{tune,arch}=native
    flags (Closes: #649461).

 -- Alessio Treglia <alessio@debian.org>  Tue, 29 Nov 2011 08:33:38 +0100

foo-yc20 (1.3.0-2) unstable; urgency=low

  * Add 0003-include-faust-dir.patch (Closes: #642662)
  * Bump Standards-Version to 3.9.2 (no changes needed)

 -- Alessandro Ghedini <al3xbio@gmail.com>  Tue, 01 Nov 2011 17:43:19 +0100

foo-yc20 (1.3.0-1) unstable; urgency=low

  * New upstream release:
    - Refactor UI codebase.
  * Refresh 0002-makefile.patch
  * debian/rules:
    - Rebuild gen/*.cpp with faust (Closes: #613044).
    - Save & restore original files.
  * debian/control:
    - Build-Depends on faust.

 -- Alessio Treglia <alessio@debian.org>  Mon, 14 Feb 2011 01:02:55 +0100

foo-yc20 (1.2.1-1) unstable; urgency=low

  * Imported Upstream version 1.2.1
  * Fixes denormalization issues in the LV2 plugin

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Tue, 25 Jan 2011 14:20:13 +0100

foo-yc20 (1.2.0-1) unstable; urgency=low

  [ Adrian Knoth ]
  * Improve package description.

  [ Alessio Treglia ]
  * New upstream release.
  * Update debian/copyright.
  * debian/rules:
    - Set buildsystem to makefile.
    - Rely on dh_auto_build rather than calling make.
    - Append -Wl,--as-needed to LDFLAGS.
  * debian/control:
    - Add Provides: lv2-plugin
    - Replace libgtkmm-2.4-dev with libgtk2.0-dev, build-depend on
      lv2core.
  * debian/patches/0002-makefile.patch: Pass LDFLAGS to the linker.

 -- Alessio Treglia <alessio@debian.org>  Thu, 20 Jan 2011 21:44:18 +0100

foo-yc20 (1.1.0-1) unstable; urgency=low

  * Initial release. (Closes: #605785)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Wed, 08 Dec 2010 23:20:12 +0100

=== debian/control ===
Source: foo-yc20
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Alessio Treglia <alessio@debian.org>
Build-Depends:
 debhelper (>= 9),
 faust,
 libgtk2.0-dev,
 libjack-dev,
 lv2-dev
Homepage: http://code.google.com/p/foo-yc20/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/foo-yc20.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/foo-yc20.git
Standards-Version: 3.9.5

Package: foo-yc20
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Provides:
 lv2-plugin
Description: YC-20 organ emulation
 The YC-20 is a divide-down combo organ designed in the late 60's. This
 emulation faithfully copies the features, sounds and flaws of the original
 organ.
 .
 Features:
    - 61 keys
    - Two main voice sections
    - Switchable bass section
    - Generator + matrix mixer => no polyphony restrictions
    - A realism control to add flaws found in the real organ
 .
 Flaws:
    - Takes quite a bit of CPU power
    - No touch vibrato
 .
 The emulation is written in Faust and uses Jack for audio and MIDI.

=== debian/watch ===
version=3

http://code.google.com/p/foo-yc20/downloads/list \
http://foo-yc20.googlecode.com/files/foo-yc20-(.*).tar.bz2
